/*********************************/
/* Code 6.6-(b) (Example 6.2.6)  */
/*********************************/
module full_adder (a, b, cin, sum, cout);
   input  a, b, cin;
   output sum, cout;
   wire   temp_sum, temp_c1, temp_c2;  // 

   half_adder u0 ( .a(a), 
                   .b(b), 
                   .sum(temp_sum), 
                   .cout(temp_c1)
                  );
   
   half_adder u1 ( .a(temp_sum), 
                   .b(cin), 
                   .sum(sum), 
                   .cout(temp_c2)
                  );
                   
   or u2 (cout, temp_c1, temp_c2);
   
endmodule